diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelBrazier.java b/src/main/java/net/minecraft/client/render/block/model/BrazierBlockModel.java
similarity index 89%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelBrazier.java
rename to src/main/java/net/minecraft/client/render/block/model/BrazierBlockModel.java
index 5c36b7387..14a1e2eaf 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelBrazier.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BrazierBlockModel.java
@@ -1,22 +1,23 @@
 package net.minecraft.client.render.block.model;
 
-import net.minecraft.client.render.stitcher.IconCoordinate;
-import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockBrazier;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.BrazierBlock;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
-public class BlockModelBrazier<T extends BlockBrazier>
-    extends BlockModelStandard<T> {
+public class BrazierBlockModel<T extends BrazierBlock>
+    extends StandardBlockModel<T> {
     protected IconCoordinate sideTexture = TextureRegistry.getTexture("minecraft:block/brazier_side");
     protected IconCoordinate baseTexture = TextureRegistry.getTexture("minecraft:block/brazier_base");
-    protected BlockModelStandard<Block> fireModel = new BlockModelFire<>(Block.fire, true).withTextures("minecraft:block/fire");
+    protected StandardBlockModel<Block> fireModel = new FireBlockModel<>(Blocks.FIRE, true).withTextures("minecraft:block/fire");
 
-    public BlockModelBrazier(Block block) {
+    public BrazierBlockModel(Block block) {
         super(block);
     }
 
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelCacaoLeaves.java b/src/main/java/net/minecraft/client/render/block/model/CacaoLeavesBlockModel.java
similarity index 93%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelCacaoLeaves.java
rename to src/main/java/net/minecraft/client/render/block/model/CacaoLeavesBlockModel.java
index d962fb936..8ab16cc30 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelCacaoLeaves.java
+++ b/src/main/java/net/minecraft/client/render/block/model/CacaoLeavesBlockModel.java
@@ -1,20 +1,20 @@
 package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.LightmapHelper;
-import net.minecraft.client.render.stitcher.IconCoordinate;
-import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
-public class BlockModelCacaoLeaves<T extends Block> extends BlockModelLeaves<T>{
+public class CacaoLeavesBlockModel<T extends Block> extends LeavesBlockModel<T> {
     protected IconCoordinate[] growthStages = new IconCoordinate[]{
             TextureRegistry.getTexture("minecraft:block/leaves_cacao_bean_stage0"),
             TextureRegistry.getTexture("minecraft:block/leaves_cacao_bean_stage1"),
             TextureRegistry.getTexture("minecraft:block/leaves_cacao_bean_stage2"),
             TextureRegistry.getTexture("minecraft:block/leaves_cacao_bean_stage3")};
-    public BlockModelCacaoLeaves(Block block) {
+    public CacaoLeavesBlockModel(Block block) {
         super(block, "minecraft:block/leaves_cacao");
     }
 
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelCactus.java b/src/main/java/net/minecraft/client/render/block/model/CactusBlockModel.java
similarity index 96%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelCactus.java
rename to src/main/java/net/minecraft/client/render/block/model/CactusBlockModel.java
index 17b00a8bc..0683630b1 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelCactus.java
+++ b/src/main/java/net/minecraft/client/render/block/model/CactusBlockModel.java
@@ -7,8 +7,8 @@ import net.minecraft.core.util.helper.Side;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
-public class BlockModelCactus<T extends Block> extends BlockModelStandard<T> {
-    public BlockModelCactus(Block block) {
+public class CactusBlockModel<T extends Block> extends StandardBlockModel<T> {
+    public CactusBlockModel(Block block) {
         super(block);
     }
 
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelCake.java b/src/main/java/net/minecraft/client/render/block/model/CakeBlockModel.java
similarity index 71%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelCake.java
rename to src/main/java/net/minecraft/client/render/block/model/CakeBlockModel.java
index 2f0d4c148..099ac455c 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelCake.java
+++ b/src/main/java/net/minecraft/client/render/block/model/CakeBlockModel.java
@@ -1,13 +1,13 @@
 package net.minecraft.client.render.block.model;
 
-import net.minecraft.client.render.stitcher.IconCoordinate;
-import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.util.helper.Side;
 
-public class BlockModelCake<T extends Block> extends BlockModelStandard<T> {
+public class CakeBlockModel<T extends Block> extends StandardBlockModel<T> {
     protected IconCoordinate cakeInner = TextureRegistry.getTexture("minecraft:block/cake_inner");
-    public BlockModelCake(Block block) {
+    public CakeBlockModel(Block block) {
         super(block);
         float f = 0.0625F;
         float f1 = 0.5F;
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelCandle.java b/src/main/java/net/minecraft/client/render/block/model/CandleBlockModel.java
similarity index 96%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelCandle.java
rename to src/main/java/net/minecraft/client/render/block/model/CandleBlockModel.java
index d7a654b06..d2feaf649 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelCandle.java
+++ b/src/main/java/net/minecraft/client/render/block/model/CandleBlockModel.java
@@ -1,12 +1,12 @@
 package net.minecraft.client.render.block.model;
 
-import net.minecraft.client.render.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.util.helper.Side;
 
-public class BlockModelCandle<T extends Block> extends BlockModelStandard<T> {
-    public BlockModelCandle(Block block) {
+public class CandleBlockModel<T extends Block> extends StandardBlockModel<T> {
+    public CandleBlockModel(Block block) {
         super(block);
     }
 
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelChest.java b/src/main/java/net/minecraft/client/render/block/model/ChestBlockModel.java
similarity index 79%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelChest.java
rename to src/main/java/net/minecraft/client/render/block/model/ChestBlockModel.java
index 9be7e9128..2844dfb7a 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelChest.java
+++ b/src/main/java/net/minecraft/client/render/block/model/ChestBlockModel.java
@@ -1,14 +1,14 @@
 package net.minecraft.client.render.block.model;
 
-import net.minecraft.client.render.stitcher.IconCoordinate;
-import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockChest;
+import net.minecraft.core.block.ChestBlock;
 import net.minecraft.core.util.helper.Axis;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
 
-public class BlockModelChest<T extends Block> extends BlockModelStandard<T>{
+public class ChestBlockModel<T extends Block> extends StandardBlockModel<T> {
     protected IconCoordinate chestFrontSingle;
     protected IconCoordinate chestFrontLeft;
     protected IconCoordinate chestFrontRight;
@@ -16,7 +16,7 @@ public class BlockModelChest<T extends Block> extends BlockModelStandard<T>{
     protected IconCoordinate chestBackRight;
     protected IconCoordinate chestSide;
     protected IconCoordinate chestTop;
-    public BlockModelChest(Block block, String rootKey) {
+    public ChestBlockModel(Block block, String rootKey) {
         super(block);
         chestFrontSingle = TextureRegistry.getTexture(rootKey + "_front");
         chestFrontLeft = TextureRegistry.getTexture(rootKey + "_left_front");
@@ -35,15 +35,15 @@ public class BlockModelChest<T extends Block> extends BlockModelStandard<T>{
             return chestTop;
         }
 
-        Side facing = BlockChest.getDirectionFromMeta(meta).getSide();
-        BlockChest.Type type = BlockChest.getTypeFromMeta(meta);
+        Side facing = ChestBlock.getDirectionFromMeta(meta).getSide();
+        ChestBlock.Type type = ChestBlock.getTypeFromMeta(meta);
 
-        if(type == BlockChest.Type.SINGLE) {
+        if(type == ChestBlock.Type.SINGLE) {
             if(side == facing) {
                 return chestFrontSingle;
             }
         }
-        if(type == BlockChest.Type.LEFT) {
+        if(type == ChestBlock.Type.LEFT) {
             if(side == facing) {
                 return chestFrontLeft;
             }
@@ -51,7 +51,7 @@ public class BlockModelChest<T extends Block> extends BlockModelStandard<T>{
                 return chestBackRight;
             }
         }
-        if(type == BlockChest.Type.RIGHT) {
+        if(type == ChestBlock.Type.RIGHT) {
             if(side == facing) {
                 return chestFrontRight;
             }
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsPumpkin.java b/src/main/java/net/minecraft/client/render/block/model/CropsPumpkinBlockModel.java
similarity index 93%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelCropsPumpkin.java
rename to src/main/java/net/minecraft/client/render/block/model/CropsPumpkinBlockModel.java
index 70735cd7b..d1cc13db0 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsPumpkin.java
+++ b/src/main/java/net/minecraft/client/render/block/model/CropsPumpkinBlockModel.java
@@ -1,13 +1,13 @@
 package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.LightmapHelper;
-import net.minecraft.client.render.stitcher.IconCoordinate;
-import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.util.helper.Side;
 
-public class BlockModelCropsPumpkin<T extends Block> extends BlockModelStandard<T>{
+public class CropsPumpkinBlockModel<T extends Block> extends StandardBlockModel<T> {
     public static final IconCoordinate[] GROWTH_STAGE_TEXTURES_TOP = {
             TextureRegistry.getTexture("minecraft:block/crops_pumpkin_stage1_top"),
             TextureRegistry.getTexture("minecraft:block/crops_pumpkin_stage2_top"),
@@ -23,7 +23,7 @@ public class BlockModelCropsPumpkin<T extends Block> extends BlockModelStandard<
 
     public static final IconCoordinate LEAF_TEXTURE = TextureRegistry.getTexture("minecraft:block/crops_pumpkin_stage0");
 
-    public BlockModelCropsPumpkin(Block block) {
+    public CropsPumpkinBlockModel(Block block) {
         super(block);
     }
 
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsWheat.java b/src/main/java/net/minecraft/client/render/block/model/CropsWheatBlockModel.java
similarity index 94%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelCropsWheat.java
rename to src/main/java/net/minecraft/client/render/block/model/CropsWheatBlockModel.java
index b141c0b91..516b1c711 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsWheat.java
+++ b/src/main/java/net/minecraft/client/render/block/model/CropsWheatBlockModel.java
@@ -1,14 +1,14 @@
 package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.LightmapHelper;
-import net.minecraft.client.render.stitcher.IconCoordinate;
-import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
 
-public class BlockModelCropsWheat<T extends Block> extends BlockModelStandard<T>{
+public class CropsWheatBlockModel<T extends Block> extends StandardBlockModel<T> {
     public final IconCoordinate[] growthStageTextures = {
             TextureRegistry.getTexture("minecraft:block/crops_wheat_stage0"),
             TextureRegistry.getTexture("minecraft:block/crops_wheat_stage1"),
@@ -20,7 +20,7 @@ public class BlockModelCropsWheat<T extends Block> extends BlockModelStandard<T>
             TextureRegistry.getTexture("minecraft:block/crops_wheat_stage7")
     };
 
-    public BlockModelCropsWheat(Block block) {
+    public CropsWheatBlockModel(Block block) {
         super(block);
     }
 
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelCrossedSquares.java b/src/main/java/net/minecraft/client/render/block/model/CrossedSquaresBlockModel.java
similarity index 95%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelCrossedSquares.java
rename to src/main/java/net/minecraft/client/render/block/model/CrossedSquaresBlockModel.java
index 7fe1d29b6..d9062f8a6 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelCrossedSquares.java
+++ b/src/main/java/net/minecraft/client/render/block/model/CrossedSquaresBlockModel.java
@@ -2,15 +2,16 @@ package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
-import net.minecraft.client.render.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.util.helper.Side;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
-public class BlockModelCrossedSquares<T extends Block> extends BlockModelStandard<T> {
-    public BlockModelCrossedSquares(Block block) {
+public class CrossedSquaresBlockModel<T extends Block> extends StandardBlockModel<T> {
+    public CrossedSquaresBlockModel(Block block) {
         super(block);
     }
     @Override
@@ -105,7 +106,7 @@ public class BlockModelCrossedSquares<T extends Block> extends BlockModelStandar
         double zd = z;
 
         // Shift grass position with deterministic position based random
-        if(block == Block.tallgrass || block == Block.tallgrassFern || block == Block.spinifex)
+        if(block == Blocks.TALLGRASS || block == Blocks.TALLGRASS_FERN || block == Blocks.SPINIFEX)
         {
             long dRandom = (x * 0x2fc20fL) ^ (long)z * 0x6ebfff5L ^ (long)y;
             dRandom = dRandom * dRandom * 0x285b825L + dRandom * 11L;
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelDoor.java b/src/main/java/net/minecraft/client/render/block/model/DoorBlockModel.java
similarity index 93%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelDoor.java
rename to src/main/java/net/minecraft/client/render/block/model/DoorBlockModel.java
index 224fb1453..391d4e5bf 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelDoor.java
+++ b/src/main/java/net/minecraft/client/render/block/model/DoorBlockModel.java
@@ -2,14 +2,14 @@ package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.RenderBlocks;
-import net.minecraft.client.render.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockDoor;
+import net.minecraft.core.block.DoorBlock;
 import net.minecraft.core.util.helper.Side;
 
-public class BlockModelDoor<T extends BlockDoor> extends BlockModelStandard<T>{
-    public BlockModelDoor(Block block) {
+public class DoorBlockModel<T extends DoorBlock> extends StandardBlockModel<T> {
+    public DoorBlockModel(Block block) {
         super(block);
     }
     
@@ -43,8 +43,8 @@ public class BlockModelDoor<T extends BlockDoor> extends BlockModelStandard<T>{
 			sideEastWest = 0.6f;
 		}
 		
-		boolean aboveIsDoor = renderBlocks.blockAccess.getBlock(x, y + 1, z) instanceof BlockDoor;
-		boolean belowIsDoor = renderBlocks.blockAccess.getBlock(x, y - 1, z) instanceof BlockDoor;
+		boolean aboveIsDoor = renderBlocks.blockAccess.getBlock(x, y + 1, z) instanceof DoorBlock;
+		boolean belowIsDoor = renderBlocks.blockAccess.getBlock(x, y - 1, z) instanceof DoorBlock;
 
 		int meta = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
 		
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelEmpty.java b/src/main/java/net/minecraft/client/render/block/model/EmptyBlockModel.java
similarity index 84%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelEmpty.java
rename to src/main/java/net/minecraft/client/render/block/model/EmptyBlockModel.java
index 826772431..19e20201c 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelEmpty.java
+++ b/src/main/java/net/minecraft/client/render/block/model/EmptyBlockModel.java
@@ -4,8 +4,8 @@ import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import org.jetbrains.annotations.Nullable;
 
-public class BlockModelEmpty extends BlockModelStandard<Block> {
-    public BlockModelEmpty(Block block) {
+public class EmptyBlockModel extends StandardBlockModel<Block> {
+    public EmptyBlockModel(Block block) {
         super(block);
     }
 
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelFarmland.java b/src/main/java/net/minecraft/client/render/block/model/FarmlandBlockModel.java
similarity index 75%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelFarmland.java
rename to src/main/java/net/minecraft/client/render/block/model/FarmlandBlockModel.java
index ec02466be..a2e4c9ac0 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelFarmland.java
+++ b/src/main/java/net/minecraft/client/render/block/model/FarmlandBlockModel.java
@@ -1,27 +1,27 @@
 package net.minecraft.client.render.block.model;
 
-import net.minecraft.client.render.stitcher.IconCoordinate;
-import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockFarmland;
+import net.minecraft.core.block.FarmlandBlock;
 import net.minecraft.core.util.helper.Side;
 
-public class BlockModelFarmland<T extends Block> extends BlockModelStandard<T>{
+public class FarmlandBlockModel<T extends Block> extends StandardBlockModel<T> {
     protected IconCoordinate topWet = TextureRegistry.getTexture("minecraft:block/farmland_wet_top");
     protected IconCoordinate topWetFertilized = TextureRegistry.getTexture("minecraft:block/farmland_wet_fertilized_top");
     protected IconCoordinate topDry = TextureRegistry.getTexture("minecraft:block/farmland_dry_top");
     protected IconCoordinate topDryFertilized = TextureRegistry.getTexture("minecraft:block/farmland_dry_fertilized_top");
     protected IconCoordinate mud = TextureRegistry.getTexture("minecraft:block/mud");
 
-    public BlockModelFarmland(Block block) {
+    public FarmlandBlockModel(Block block) {
         super(block);
     }
 
     @Override
     public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, final int data)
     {
-        boolean isWet = BlockFarmland.isWet(data);
-        boolean isFertilized = BlockFarmland.isFertilized(data);
+        boolean isWet = FarmlandBlock.isWet(data);
+        boolean isFertilized = FarmlandBlock.isFertilized(data);
 
         if (side == Side.TOP) {
             if (isWet && isFertilized) {
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelFence.java b/src/main/java/net/minecraft/client/render/block/model/FenceBlockModel.java
similarity index 97%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelFence.java
rename to src/main/java/net/minecraft/client/render/block/model/FenceBlockModel.java
index 4829a7b28..c9b06bace 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelFence.java
+++ b/src/main/java/net/minecraft/client/render/block/model/FenceBlockModel.java
@@ -3,13 +3,13 @@ package net.minecraft.client.render.block.model;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockFence;
+import net.minecraft.core.block.FenceBlock;
 import net.minecraft.core.util.helper.Side;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
-public class BlockModelFence<T  extends BlockFence> extends BlockModelStandard<T> {
-    public BlockModelFence(Block block) {
+public class FenceBlockModel<T  extends FenceBlock> extends StandardBlockModel<T> {
+    public FenceBlockModel(Block block) {
         super(block);
     }
 
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceGate.java b/src/main/java/net/minecraft/client/render/block/model/FenceGateBlockModel.java
similarity index 97%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelFenceGate.java
rename to src/main/java/net/minecraft/client/render/block/model/FenceGateBlockModel.java
index 2c249770e..76fcf3ee0 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceGate.java
+++ b/src/main/java/net/minecraft/client/render/block/model/FenceGateBlockModel.java
@@ -3,13 +3,13 @@ package net.minecraft.client.render.block.model;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockFenceGate;
+import net.minecraft.core.block.FenceGateBlock;
 import net.minecraft.core.util.helper.Side;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
-public class BlockModelFenceGate<T extends BlockFenceGate> extends BlockModelStandard<T>{
-    public BlockModelFenceGate(Block block) {
+public class FenceGateBlockModel<T extends FenceGateBlock> extends StandardBlockModel<T> {
+    public FenceGateBlockModel(Block block) {
         super(block);
     }
 
@@ -18,8 +18,8 @@ public class BlockModelFenceGate<T extends BlockFenceGate> extends BlockModelSta
         block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
         boolean flag = true;
         int l = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
-        boolean flag1 = BlockFenceGate.func_35291_d(l);
-        int i1 = BlockFenceGate.func_35290_f(l);
+        boolean flag1 = FenceGateBlock.func_35291_d(l);
+        int i1 = FenceGateBlock.func_35290_f(l);
         if(i1 == 3 || i1 == 1)
         {
             float f = 0.4375F;
diff --git a/src/main/java/net/minecraft/client/render/block/model/FenceGatePaintedBlockModel.java b/src/main/java/net/minecraft/client/render/block/model/FenceGatePaintedBlockModel.java
new file mode 100644
index 000000000..9e0419584
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/block/model/FenceGatePaintedBlockModel.java
@@ -0,0 +1,18 @@
+package net.minecraft.client.render.block.model;
+
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.FenceGateBlock;
+import net.minecraft.core.util.helper.Side;
+
+public class FenceGatePaintedBlockModel<T extends FenceGateBlock> extends FenceGateBlockModel<T> {
+    public FenceGatePaintedBlockModel(Block block) {
+        super(block);
+    }
+
+    @Override
+    public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int meta) {
+        meta = meta >> 4;
+        return PlanksPaintedBlockModel.texCoords[meta & 0x0F];
+    }
+}
diff --git a/src/main/java/net/minecraft/client/render/block/model/FencePaintedBlockModel.java b/src/main/java/net/minecraft/client/render/block/model/FencePaintedBlockModel.java
new file mode 100644
index 000000000..86aca6978
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/block/model/FencePaintedBlockModel.java
@@ -0,0 +1,19 @@
+package net.minecraft.client.render.block.model;
+
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.FenceBlock;
+import net.minecraft.core.util.helper.Side;
+
+public class FencePaintedBlockModel<T extends FenceBlock> extends FenceBlockModel<T> {
+
+
+    public FencePaintedBlockModel(Block block) {
+        super(block);
+    }
+
+    @Override
+    public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int meta) {
+        return PlanksPaintedBlockModel.texCoords[meta & 15];
+    }
+}
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceThin.java b/src/main/java/net/minecraft/client/render/block/model/FenceThinBlockModel.java
similarity index 98%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelFenceThin.java
rename to src/main/java/net/minecraft/client/render/block/model/FenceThinBlockModel.java
index 8e5fbf685..9dd8e40a6 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceThin.java
+++ b/src/main/java/net/minecraft/client/render/block/model/FenceThinBlockModel.java
@@ -3,21 +3,21 @@ package net.minecraft.client.render.block.model;
 import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.RenderBlocks;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
-import net.minecraft.client.render.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockFenceThin;
+import net.minecraft.core.block.ThinFenceBlock;
 import net.minecraft.core.util.helper.Direction;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
-public class BlockModelFenceThin<T extends BlockFenceThin> extends BlockModelStandard<T> {
+public class FenceThinBlockModel<T extends ThinFenceBlock> extends StandardBlockModel<T> {
     private final IconCoordinate texIndex;
     private final IconCoordinate bottomTexIndex;
     private final IconCoordinate topTexIndex;
     private final IconCoordinate columnTexIndex;
 
-    public BlockModelFenceThin(Block block, IconCoordinate texIndex, IconCoordinate bottomTexIndex, IconCoordinate topTexIndex, IconCoordinate columnTexIndex){
+    public FenceThinBlockModel(Block block, IconCoordinate texIndex, IconCoordinate bottomTexIndex, IconCoordinate topTexIndex, IconCoordinate columnTexIndex){
         super(block);
         this.texIndex = texIndex;
         this.bottomTexIndex = bottomTexIndex;
